<template>
  <client-only>
    <gl-drawer header-sticky open @close="$emit('close')">
      <template #title>Group by help</template>

      <section>
        <p>Most grouping options are self explanatory. The below explains the less obvious ones.</p>
        <h3 class="gl-heading-3">{{ customGroupingName }}</h3>
        <p>
          This creates groups dynamically, based on the current <b>Filter</b>. The filter is
          decomposed into the separate <code>or</code> subfilters, and each one of those represents
          a group.
        </p>
        <p>
          For example, given the filter <code>check_id co "foo" or path ew ".js"</code>, the
          resulting groups would be:
        </p>
        <ol>
          <li><code>check_id co "foo"</code></li>
          <li><code>path ew ".js"</code></li>
        </ol>
        <p>
          Any brackets in the filter are expanded out to produce all possible subfilters. For
          example, given the filter
          <code>(path co "foo" or path co "bar") and (check_id eq "a" or check_id eq "b")</code>,
          the resulting groups would be:
        </p>
        <ol>
          <li><code>path co "foo" and check_id eq "a"</code></li>
          <li><code>path co "foo" and check_id eq "b"</code></li>
          <li><code>path co "bar" and check_id eq "a"</code></li>
          <li><code>path co "bar" and check_id eq "b"</code></li>
        </ol>
        <p>
          Unlike other grouping options, this can result in findings appearing in more than one
          group, depending on how the filter is written. For instance, in the example above, a
          finding from the <code>foo</code> rule in a JS file would be shown in both groups, because
          it matches both subfilters.
        </p>
        <h3 class="gl-heading-3">{{ customExplicitGroupingName }}</h3>
        <p>
          This is similar to <b>{{ customGroupingName }}</b
          >, but doesn't expand out bracketed expressions. It is more verbose, but more
          flexible/powerful. Write bracketed subfilters separated by <code>or</code> operations, and
          each bracketed subfilter will become a group.
        </p>
        <p>
          For example, given the filter
          <code>(check_id co "foo" or check_id co "bar") or extra.lines co "qux"</code>, the groups
          would be:
        </p>
        <ol>
          <li><code>check_id co "foo" or check_id co "bar"</code></li>
          <li><code>extra.lines co "qux"</code></li>
        </ol>
      </section>
    </gl-drawer>
  </client-only>
</template>

<script>
import GlDrawer from '@gitlab/ui/src/components/base/drawer/drawer.vue';
import { groupByOptions, GROUP_BY_FILTER, GROUP_BY_EXPLICIT_FILTER } from './group_by.vue';

export default {
  name: 'GroupBy',
  components: {
    GlDrawer,
  },
  props: {
    open: {
      type: Boolean,
      required: true,
    },
  },
  computed: {
    customGroupingName() {
      return groupByOptions.find((option) => option.value === GROUP_BY_FILTER).text;
    },
    customExplicitGroupingName() {
      return groupByOptions.find((option) => option.value === GROUP_BY_EXPLICIT_FILTER).text;
    },
  },
  groupByOptions,
};
</script>
